#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "midas.h"

#define EVENT_SIZE 1000

main()
{
INT     hBuf, status;
char    event[EVENT_SIZE];
INT     bytes_sent, serial_number=1;
INT     start, stop;
char    host_name[256];

  printf("Host to connect: ");
  ss_gets(host_name, 256);

  /* connect to experiment */
  cm_connect_experiment(host_name, "", "Producer", NULL);

  /* open the event buffer with default size */
  bm_open_buffer("SYSTEM", 0x100000, &hBuf);

  /* set the buffer write cache size */
  bm_set_cache_size(hBuf, 0, 50000);

  do
    {
    start = ss_millitime();
    bytes_sent = 0;

    do
      {
      /* compose an event header with increasing serial number */
      bm_compose_event((EVENT_HEADER *) event, 1, 1,
                        EVENT_SIZE, serial_number++);

      /* send event */
      status = rpc_send_event(hBuf, event, 
                              EVENT_SIZE+sizeof(EVENT_HEADER), SYNC);

      bytes_sent += EVENT_SIZE;

      /* repeat this loop for 1s */
      } while (ss_millitime() - start < 1000);

    /* Now calculate the rate */
    stop = ss_millitime();
    if (stop != start)
      printf("Rate: %1.2lf MB/sec\n", 
        bytes_sent/1024.0/1024.0/(stop/1000.0 - start/1000.0));

    status = cm_yield(0);
    } while (status != RPC_SHUTDOWN && status != SS_ABORT);

  cm_disconnect_experiment();
  return 1;
}
