#include <stdio.h>
#include "midas.h"
#include "class/multi.h"
#include "class/hv.h"
#include "device/mscbdev.h"
#include "device/nulldev.h"
#include "bus/null.h"


/*-- Globals -------------------------------------------------------*/

char *frontend_name      = "SC Frontend";
char *frontend_file_name = __FILE__;
BOOL frontend_call_loop  = FALSE;
INT  display_period      = 1000;
INT  max_event_size      = 10000;
INT  max_event_size_frag = 5*1024*1024;
INT  event_buffer_size   = 10*10000;

/*-- Equipment list ------------------------------------------------*/

DEVICE_DRIVER multi_driver[] = {
  { "Input",   mscbdev, 2, NULL, DF_INPUT },
  { "Output",  mscbdev, 1, NULL, DF_OUTPUT | DF_PRIO_DEVICE },
  { "" }
};

DEVICE_DRIVER hv_driver[] = {
  { "Dummy Device", nulldev, 16, null },
  { "" }
};

EQUIPMENT equipment[] = {

  { "HV",                 /* equipment name */
    { 3, 0,                 /* event ID, trigger mask */
      "SYSTEM",             /* event buffer */
      EQ_SLOW,              /* equipment type */
      0,                    /* event source */
      "MIDAS",              /* format */
      TRUE,                 /* enabled */
      RO_RUNNING |
      RO_TRANSITIONS,       /* read when running and on transitions */
      60000,                /* read every 60 sec */
      0,                    /* stop run after this event limit */
      0,                    /* number of sub events */
      1,                    /* log history every event */
      "", "", "", },
    cd_hv_read,           /* readout routine */
    cd_hv,                /* class driver main routine */
    hv_driver,            /* device driver list */
    NULL,                 /* init string */
  },

  { "Environment",        /* equipment name */
    { 4, 0,                 /* event ID, trigger mask */
      "SYSTEM",             /* event buffer */
      EQ_SLOW,              /* equipment type */
      0,                    /* event source */
      "MIDAS",              /* format */
      TRUE,                 /* enabled */
      RO_RUNNING |
      RO_TRANSITIONS,       /* read when running and on transitions */
      60000,                /* read every 60 sec */
      0,                    /* stop run after this event limit */
      0,                    /* number of sub events */
      1,                    /* log history every event */
      "", "", "", },
    cd_multi_read,        /* readout routine */
    cd_multi,             /* class driver main routine */
    multi_driver,         /* device driver list */
    NULL,                 /* init string */
  },

  { "" }
};

/*-- Dummy routines ------------------------------------------------*/

INT  poll_event(INT source[], INT count, BOOL test) {return 1;};
INT  interrupt_configure(INT cmd, INT source[], PTYPE adr) {return 1;};

/*-- Frontend Init -------------------------------------------------*/

INT frontend_init()
{
  return CM_SUCCESS;
}

/*-- Frontend Exit -------------------------------------------------*/

INT frontend_exit()
{
  return CM_SUCCESS;
}

/*-- Frontend Loop -------------------------------------------------*/

INT frontend_loop()
{
  return CM_SUCCESS;
}

/*-- Begin of Run --------------------------------------------------*/

INT begin_of_run(INT run_number, char *error)
{
  return CM_SUCCESS;
}

/*-- End of Run ----------------------------------------------------*/

INT end_of_run(INT run_number, char *error)
{
  return CM_SUCCESS;
}

/*-- Pause Run -----------------------------------------------------*/

INT pause_run(INT run_number, char *error)
{
  return CM_SUCCESS;
}

/*-- Resuem Run ----------------------------------------------------*/

INT resume_run(INT run_number, char *error)
{
  return CM_SUCCESS;
}

/*------------------------------------------------------------------*/
