package ca.triumf.midas;

import java.lang.*;

/**
 * The OdbKeyUpdate interface is used to define a callback to be called by 
  the hotlink attached to an OdbKey handle. This 
  callback will be triggered on a change of value for the OdbKey variable. 

  The operation of the callback must account for the possibility of the Larsen effect 
  when modifiying values in the ODB.
 */
public interface OdbKeyUpdate { 
	
	/**
	 * This function will be called for any key with a hotlink attached for the client.
	 
	   @param key the handle of the key whos value changed
	 */
  public void update(OdbKey key); 
}